edeactivatePackage(SpamReduce);

if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
  {
   if (!$RTB::RTBR_ServerControl_Hook)
     exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

   RTB_registerPref("Max Brick Height"       ,"Spam Reducer","Pref::Server::Brickheight","int 0 500","Script_SpamReduce",75,0,1);
   RTB_registerPref("Max Brick Height(admin)","Spam Reducer","Pref::Server::AdminBrickheight","int 0 500","Script_SpamReduce",250,0,1);
   RTB_registerPref("Max 1x1 Percent (%)"    ,"Spam Reducer","Pref::Server::BrickPercentbrick1x1Data","int 0 100","Script_SpamReduce",20,0,1);
   RTB_registerPref("Max 1x1x5 Percent (%)"  ,"Spam Reducer","Pref::Server::BrickPercentbrick1x1x5Data","int 0 100","Script_SpamReduce",25,0,1);
   }
else
  {
   if ($Pref::Server::BrickHeight $= "")
     {
      $Pref::Server::BrickHeight=75;
     }
   if ($Pref::Server::AdminBrickHeight $= "" )
     {
      $Pref::Server::AdminBrickHeight=250;
     }
   if ( $Pref::Server::BrickPercent[brick1x1Data] $= "")
     {
      $Pref::Server::BrickPercent[brick1x1Data] = 20;  // max 20% of players total bricks can be a 1x1
     }
   if ( $Pref::Server::BrickPercent[brick1x51Data] $= "")
     {
      $Pref::Server::BrickPercent[brick1x1x5Data] = 25;  // max 25% of players total bricks can be a 1x1x5
     }
  }

package SpamReduce
 {
  // for each brick planted, check to see if its one we are tracking, and if so make sure it doesnt exceed
  // the allowed percentage
  function serverCmdPlantBrick(%client)
     {
      if ( !isObject(%client.player.tempBrick)
        {
         return Parent::serverCmdPlantBrick(%client);
        }

      %pos = %client.player.tempBrick.getPosition();
      %x = getword(%pos, 0);
      %y = getWord(%pos, 1);

      if ( ( %x < -1024) || (%x > 1024) )
        {
         %client.centerPrint("Error: Brick outside mission area: " @ %x, 3);
         return;
        }
      if ( (%y < -1024) || (%y > 1024) )
        {
         %client.centerPrint("Error: Brick outside mission area: " @ %y, 3);
         return;
        }

      %z = getWord(%pos, 2);
      if (%client.isAdmin)
        {
         if ( %z > $Pref::Server::AdminBrickHeight)
           {
            %client.centerPrint("Error: Brick too high: " @ %z @ " max admin height is " @ $Pref::Server::AdminBrickHeight, 3);
            return;
           }
        }
      else
        {
         if ( %z > $Pref::Server::BrickHeight)
           {
            %client.centerPrint("Error: Brick too high: " @ %z @ " max height is " @ $Pref::Server::BrickHeight, 3);
            return;
           }
        }

      // check to see if adding this brick will put us over the limit
      %db = %client.player.tempBrick.getDataBlock();
      %dbName = %db.getName();
      if ( $Pref::Server::Brickpercent[%dbName] > 0)
        {
         %total = %client.brickgroup.getCount();  // subtract 1 for temp brick
         %percent = ((%client.brickTrack[%dbName] + 1) / %total) * 100;
         //echo("total: " @ %total @ " brickTrack: " @ %client.brickTrack[%dbName] @ " percent: " @ %percent);
         if (  %percent > $Pref::Server::BrickPercent[%dbName])
           {
            %client.centerPrint("<color:ff0000>Error:<color:ffffff> Too many <color:ffff00>" @ %db.uiName @ "<color:ffffff> bricks.  Max % is " @ $Pref::Server::BrickPercent[%dbName] @ "% of total. You are at " @ mFloor(%percent) @ "% Use other bricks instead", 5);
            return;
           }
        }

      %newBrick = Parent::serverCmdPlantBrick(%client);
      if ( isObject(%newBrick) )
        {
         if ( $Pref::Server::BrickPercent[%dbName] > 0)
           {
            %client.brickTrack[%dbName]++;
            //%total = %client.brickgroup.getCount() - 1;  // add 1 for temp brick
            //echo("client: " @ %client @ " has " @ %client.brickTrack[%dbName] SPC %dbName @ " of " @ %total);
            //echo( %client.brickTrack[%dbName] / %total );
           }
        }
     }

  function fxDTSBrick::onRemove(%this, %arga, %argb)
    {
     // track brick removals here
     if ( isObject(%this.client) )
       {
        %dbName = %this.getDatablock().getName();
        if ( $Pref::Server::BrickPercent[%dbName] > 0)
          {
           %this.client.brickTrack[%dbName]--;
           if ( %this.client.brickTrack[%dbName] < 0)
             {
              %this.client.brickTrack[%dbName] = 0;
             }
           //echo("client: " @ %this.client @ " has " @ %this.client.brickTrack[%dbName] SPC %dbName);
         }
       }
     Parent::onremove(%this, %arga, %argb);
    }

};

activatePackage(SpamReduce);
